# -*- coding: latin-1 -*-

from Products.Archetypes.public import BaseSchema, BaseFolderSchema, Schema

from Products.Archetypes.public import StringField, StringWidget, PasswordWidget
from Products.Archetypes.public import SelectionWidget, MultiSelectionWidget
from Products.Archetypes.public import TextField, TextAreaWidget
from Products.Archetypes.public import LinesField, LinesWidget
from Products.Archetypes.public import IntegerField, IntegerWidget
from Products.Archetypes.public import DateTimeField, CalendarWidget
from Products.Archetypes.public import FileField, FileWidget
from Products.Archetypes.public import RichWidget, VisualWidget
from Products.Archetypes.public import BooleanField, BooleanWidget
from Products.Archetypes.public import ReferenceField, ReferenceWidget

from Products.Archetypes.public import BaseContent, registerType, DisplayList
from Products.Archetypes.Marshall import RFC822Marshaller, PrimaryFieldMarshaller

def toHex(ust):
    "Converts unicode string to hex"
    return ust.encode('utf-8').encode('hex')

message_client_schema = BaseFolderSchema + Schema((


    StringField('name',
        widget = StringWidget(
            label = 'Your Name',
            description = 'Eg. FirstName LastName',
            i18n_domain = "mxmimapclient",
            label_msgid = "label_name",
            description_msgid = "help_name",
        ),
    ),


    StringField('email',
        widget = StringWidget(
            label = 'Email address',
            description = 'Eg. name@example.com',
            i18n_domain = "mxmimapclient",
            label_msgid = "label_email",
            description_msgid = "help_email",
        ),
    ),


    StringField('username',
        widget = StringWidget(
            label = 'Messageserver login',
            description = 'Your username at the mailserver',
            i18n_domain = "mxmimapclient",
            label_msgid = "label_username",
            description_msgid = "help_username",
        ),
    ),


    StringField('password',
        widget = PasswordWidget(
            label = 'Your messageserver password',
            description = 'Only you can tell :-)',
            i18n_domain = "mxmimapclient",
            label_msgid = "label_password",
            description_msgid = "help_password",
        ),
    ),


#    StringField('password',
#        widget = StringWidget(
#            label = 'Your messageserver password',
#            description = 'Only you can tell :-)',
#        ),
#    ),


    StringField('incommingServer',
        widget = StringWidget(
            label = 'Incoming server',
            description = 'Name of the incomming Imap server. Eg. imap.example.com',
            i18n_domain = "mxmimapclient",
            label_msgid = "label_incommingServer",
            description_msgid = "help_incommingServer",
        ),
    ),


    StringField('smtpServer',
        widget = StringWidget(
            label = 'Outgoing server',
            description = 'Address of outgoing smtp server Eg. smtp.somewhere.com',
            i18n_domain = "mxmimapclient",
            label_msgid = "label_smtpServer",
            description_msgid = "help_smtpServer",
        ),
    ),


#    StringField('inboxName',
#        widget = SelectionWidget(
#            format = 'flex',
#            label = 'Name of the inbox',
#            description = 'Eg. INBOX',
#        ),
#        default='INBOX',
#        vocabulary = 'getFolderDisplayList',
#    ),
#
#
#    StringField('sentboxName',
#        widget = SelectionWidget(
#            format = 'flex',
#            label = 'Name of the sentbox',
#            description = "Eg. 'Sent', 'Sent Items' or 'INBOX.Sent'",
#        ),
#        default='Sent',
#        vocabulary = 'getFolderDisplayList',
#    ),
#
#
#    StringField('trashboxName',
#        widget = SelectionWidget(
#            format = 'flex',
#            label = 'Name of the trashbox',
#            description = "Eg. 'Trash' or 'INBOX.Trash'",
#        ),
#        default='Trash',
#        vocabulary = 'getFolderDisplayList',
#    ),


    ReferenceField('inboxFolder',
        widget = SelectionWidget(
            format = 'flex',
            label = 'Name of the inbox',
            description = 'Eg. INBOX',
            i18n_domain = "mxmimapclient",
            label_msgid = "label_inboxFolder",
            description_msgid = "help_inboxFolder",
        ),
        relationship='inbox_of',
        vocabulary = 'getFolderDisplayList',
    ),


    ReferenceField('sentboxFolder',
        widget = SelectionWidget(
            format = 'flex',
            label = 'Name of the sentbox',
            description = "Eg. 'Sent', 'Sent Items' or 'INBOX.Sent'",
            i18n_domain = "mxmimapclient",
            label_msgid = "label_sentboxFolder",
            description_msgid = "help_sentboxFolder",
        ),
        relationship='sentbox_of',
        vocabulary = 'getFolderDisplayList',
    ),


    ReferenceField('trashboxFolder',
        widget = SelectionWidget(
            format = 'flex',
            label = 'Name of the trashbox',
            description = "Eg. 'Trash' or 'INBOX.Trash'",
            i18n_domain = "mxmimapclient",
            label_msgid = "label_trashboxFolder",
            description_msgid = "help_trashboxFolder",
        ),
        relationship='trashbox_of',
        vocabulary = 'getFolderDisplayList',
    ),


    #############

    IntegerField('updateInterval',
        widget = IntegerWidget(
            label = 'Update Interval',
            description = "How often should new messages be fetched from the server. In minutes.",
            i18n_domain = "mxmimapclient",
            label_msgid = "label_updateInterval",
            description_msgid = "help_updateInterval",
        ),
        default = 10,
    ),


    ),
    marshall=PrimaryFieldMarshaller(),

)


message_folder_schema = BaseSchema

